//+------------------------------------------------------------------+
//|                                                         Open.mqh |
//|                                        Nickityuk Nickolay, 2017. |
//|                             https://www.mql5.com/users/nicityuk/ |
//+------------------------------------------------------------------+
#property copyright "Nickityuk Nickolay, 2017."
#property link      "https://www.mql5.com/users/nicityuk/"
#include "Init.mqh"
#include "Timer.mqh"
#include "Lot.mqh"
#include "Cross.mqh"
long v,x;
int copied;
//+------------------------------------------------------------------+
void CheckVolumeB()         
  {//go trading only for first tiks of new bar
   int i;
   //ArraySetAsSeries(rates,true);
   datetime start=rates[0].time; 
   datetime stop=rates[4].time;
   //MqlRates rates[];
   //long tick_volume[];
   copied=CopyRates(NULL,PERIOD_M1,start,stop,rates); 
   if(copied>0) {v=0;
     for(i=0;i<5;i++) 
       {x=rates[i].tick_volume; v+=x;}}
   else return;     
   if(v-800/12<0) {return;}
   else OrderSendB();}
//+------------------------------------------------------------------+
void CheckVolumeS()         
  {//go trading only for first tiks of new bar
   int i;
   ArraySetAsSeries(rates,true);
   datetime start=rates[0].time; 
   datetime stop=rates[4].time;
   copied=CopyRates(NULL,PERIOD_M1,start,stop,rates); 
   if(copied>0) {v=0;
     for(i=0;i<5;i++) 
       {x=rates[i].tick_volume; v+=x;}}
   else return;     
   if(v-800/12<0) {return;}
   else OrderSendS();}
//+------------------------------------------------------------------+
//| Check for open position conditions                               |
//+------------------------------------------------------------------+
void Open()
  {//--- get Moving Average 
   double ma[3];
   if(CopyBuffer(HMA,0,0,3,ma)!=3)
     {Print("CopyBuffer from iMA failed, no data"); return;}
//--- get Ichimoku Kinko Hyo 
   double kj[4];
   if(CopyBuffer(HIKH,1,0,4,kj)!=4)
     {Print("CopyBuffer from iIchimoku failed, no data"); return;}       
//--- check signals
   datetime tss=0,tsb=0,tss2=0,tsb2=0;
   ENUM_ORDER_TYPE signal=WRONG_VALUE;
   if(kj[1]-kj[0]>0 && kj[0]-rates[0].close>0) {tss2=TimeCurrent();}
   CrossS(); if(0<=tss2-tss && tss2-tss<43200) {signal=ORDER_TYPE_SELL;} // sell conditions
   if(kj[1]-kj[0]<0 && kj[0]-rates[0].close<0) {tsb2=TimeCurrent();}
   CrossB(); if(0<=tsb2-tsb && tsb2-tsb<43200) {signal=ORDER_TYPE_BUY;}  // buy conditions   
   //if(rates[1].close-kj[1]>0 && rates[0].close-kj[0]<0)
     //{if(kj[1]-kj[0]>=0) {signal=ORDER_TYPE_SELL;}} // sell conditions  
   //else if(rates[1].close-kj[1]<0 && rates[0].close-kj[0]>0)
     //     {if(kj[1]-kj[0]<=0) {signal=ORDER_TYPE_BUY;}}  // buy conditions
//--- additional checking
   if(signal!=WRONG_VALUE)
     {if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && Bars(_Symbol,_Period)>30)
        {if(signal==ORDER_TYPE_SELL) {CheckVolumeS();}
         if(signal==ORDER_TYPE_BUY)  {CheckVolumeB();}
         else return;}
      else return;}
   else Print("signal=WRONG_VALUE"); return;}
//--------------------------------------------------------------